/*
 *			F D V E R I F Y . C
 *
 *	This function is for paranoid setuid programs that
 *	want to be sure they wont clobber files when they
 *	print errors.  You never know when some malicious
 *	user will come along and close all your filedescriptors,
 *	or open them all.  This module assumes that the program
 *	wants all fd's 0-2 open and 3-_NFILE closed.
 */
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>

static char *Devnull = "/dev/null";

fdverify()
{
	register int i;
	struct stat sb;

	if(fstat(0, &sb))
		open(Devnull, 2);
	if(fstat(1, &sb))
		open(Devnull, 2);
	if(fstat(2, &sb))
		open(Devnull, 2);
	if(fstat(0, &sb) || fstat(1, &sb) || fstat(2, &sb))
		exit(111);
#ifndef _NFILE
	for (i = getdtablesize()-1; i > 2; i--)
#else
	for (i = _NFILE-1; i > 2; i--)
#endif
		close(i);
}
