#
/*
 *		M U L T I - D E V I C E   Q U E U E I N G   S Y S T E M
 *
 *				  D R E C O V E R . C
 *
 *				Douglas P. Kingston III
 *
 *				Part of the MDQS Daemon
 */

#include <stdio.h>
#include "queue.h"		/* Includes <sys/types.h> */
#include "dirent.h"

#ifdef DIRBLKSIZ		/* 4BSD flavor assumed */
#define	dirent	direct
#endif

extern	char *Newprefix;
extern	char *Qcntrldir;
extern	int Debug;
extern	int Waveoff;

/*
 *	R E C O V E R ( )
 *
 *	This function is called once when the daemon is started up.
 *	All jobs in the queue are enrolled into the daemons queues
 *	unless there is not enough space in which case, they are linked
 *	into the new directory which will cause them to be read later.
 */
recover()
{
	register struct	dirent *dirp;
	register DIR	*dirf;
	char	newname[PATHSIZ];

	/*
	 *	Read in all the requests in the control directory.
	 *	If we run out of space, then just start linking
	 *	to the Newdir so the daemon will accept them when
	 *	it has space.
	 */
	if(( dirf = opendir( Qcntrldir )) == NULL ) {
		complain( "recover() cannot open %s, recovery aborted.",
			Qcntrldir );
		return;
	}

	while(( dirp = readdir( dirf )) != NULL ) {
		if( dirp->d_name[0] != 'Q')
			continue;

debug("Recovering %s.", dirp->d_name);
		if( ! Waveoff ) {
			enroll( dirp->d_name );
			rmreq( Newprefix, dirp->d_name, QUIET );
		} else {
			/* The daemon's queues are full, link to Newdir */
			sprintf(newname, "%s/%s", Newprefix, dirp->d_name);
			if( link( dirp->d_name, newname ) && Debug )
debug("Link failed (%s, %s).", newname, sys_errlist[errno] );
		}
	}
	closedir( dirf );
}
