/*
 *			N E T D A E M O N . C
 *
 *  Server MDQS daemon, for 4.1a/4.2 BSD by DPK at BRL, 1 Jan 82 (Sigh...)
 *
 *		R E V I S I O N   H I S T O R Y
 */

#include <stdio.h>
#include <signal.h>
#include "queue.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/wait.h>
#include <pwd.h>

extern	int errno;
extern	char *Tmpqdir;

struct sockaddr_in addr;

char	*MDQSlogin = "mdqs";
char	obuf[BUFSIZ];		/* Logging will be line buffered */
char	*srvargv[MAXFIELDS];	/* Actual smtp server process, full path */
int	srvargc = 0;

struct paramtab paramtab[] = {
	"mdqsid",	STRPVAR,	&MDQSlogin,		NULL,
	0,		0,		0,			0
};

main (argc, argv)
int	argc;
char	**argv;
{
	register int	skt;
	int	pid;
	char	*them;
	char	hostname[32];
	char	workarea[32];
	struct	passwd *pw;
	struct sockaddr_in rmtaddr;
	int	len_rmtaddr = sizeof rmtaddr;
	int	status;
	register struct hostent *hp;


	rdconf (paramtab);

	setbuf( stdout, obuf );
	gethostname( hostname, sizeof(hostname));	/* current hostname */

	if (chdir (Tmpqdir) < 0)
		netbomb ("Can't chdir to %s (%s)", Tmpqdir, sys_errlist[errno]);

	if ((pw = getpwnam(MDQSlogin)) == NULL)
		netbomb ("Can't find MDQSlogin (%s) in /etc/passwd", MDQSlogin);

	/* Parse args; args will override configuration file... */
	arginit( argc, argv );

	if (getpeername (0, &rmtaddr, &len_rmtaddr) < 0)
		netbomb ("getpeername failed");

	hp = gethostbyaddr ( &rmtaddr.sin_addr,
		sizeof rmtaddr.sin_addr, AF_INET );
	if( hp == NULL ) {
		/* This should produce a dotted quad */
		sprintf( workarea, "%lx", them );
		hp->h_name = &workarea[0];
	}

	setgid(pw->pw_gid);
	setuid(pw->pw_uid);
	srvargv[srvargc++] = "-h";
	srvargv[srvargc++] = hp->h_name;
	srvargv[srvargc] = 0;
	execv (*srvargv, srvargv);
	netbomb( "server exec error (%d)", errno);
}

arginit( argc, argv )
int	argc;
char	**argv;
{
	register char	*arg;
	register int i = 1;
	register int j = 0;

	if( argc < 2 )
		netbomb( "Usage: netdae server [args]");

	if( access( argv[1], 01 ) < 0 )		/* execute privs? */
		netbomb( "Cannot access server program '%s'", argv[i] );

	srvargv[j++] = argv[i++];
	while (argv[i])
		srvargv[j++] = argv[i++];	
	srvargv[j] = 0;
	srvargc = j;
}

/* VARARGS */
netbomb( fmt, a, b, c, d )
char *fmt;
{
	fputs( "400 ", stdout );
	fprintf( stdout, fmt, a, b, c, d );
	fputc( '\r\n', stdout );
	fflush( stdout );
}
