/*
 *	vcopyn - transcribe arbitrary input file to stdout (for MDQS)
 *
 *	Versatec Version adapted from lpf.c/vpf.c.	12 Feb 83	DAW
 */

#include	<stdio.h>
#include	<sgtty.h>
#include	"vp.h"
#include	"queue.h"

#define	VERSATEC
#define output(c,fp)	putc(c,fp)

#define	LINELN	132
#define	EJLINE	63
#define SKPLINE	0

int	anydone;
char	linebuf[LINELN+2];
int	ov;
char	ovbuf[2*LINELN];
FILE	*out = stdout;
int	npages	= 1;
int	lineno;
int	vprtmode[]	= prtmode;
int	vpltmode[]	= pltmode;

long
copyn( in, llimit )			/* returns # input lines done,
					   no more than llimit+PAGE-1 */
register FILE	*in;		/* input stream     */
long		llimit; 	/* input line limit */
{
	register int nskipped;

	lineno = 0;
	nskipped = 0;
	while (getline( in )) {
		if (lineno==0 && linebuf[0]==0 && nskipped<SKPLINE+3) {
			nskipped++;
			continue;
		}
		if (lineno >= EJLINE) {
			nskipped = 0;
			putline(1);
			lineno = 0;
		} else {
			putline(0);
			lineno++;
		}
	}
	if (lineno>0)
		npages++;
	return(1);
}

getline( in )
FILE	*in;	/* the input data stream */
{
	register int col, maxcol, c;

	ov = 0;
	for (col=0; col<LINELN; col++) {
		linebuf[col] = ' ';
		ovbuf[2*col] = ovbuf[2*col+1] = 0;
	}
	col = 0;
	maxcol = 0;
	for (;;) switch (c = getc(in)) {

	case EOF:
		return(0);

	default:
		if (c>=' ') {
			if (col < LINELN) {
				if (linebuf[col]=='_') {
					ov++;
					ovbuf[2*col] = ovbuf[2*col+1] = 0377;
				}
				linebuf[col++] = c;
				if (col > maxcol)
					maxcol = col;
			}
		}
		continue;

	case '\f':
		lineno = EJLINE;
		if ( maxcol >= LINELN )
			maxcol = LINELN;
		linebuf[ maxcol ] = 0;
		return ( 1 );

	case ' ':
		col++;
		continue;

	case '\t': 	/* expand tabs */
		col = (col|07) + 1;
		if (col>maxcol)
			maxcol = col;
		continue;

	case '\r':
		col = 0;
		continue;

	case '_':
		if (col>=LINELN) {
			col++;
			continue;
		}
		if (linebuf[col]!=' ') {
			ovbuf[2*col] = ovbuf[2*col+1] = 0377;
			ov++;
		} else
			linebuf[col] = c;
		col++;
		if (col>maxcol)
			maxcol = col;
		continue;

	case '\n':
		if (maxcol>=LINELN)
			maxcol = LINELN;
		linebuf[maxcol] = 0;
		return(1);

	case '\b':
		if (col>0)
			col--;
		continue;
	}
}

putline(ff)
{
	register char *lp;
	register int c;
	extern errno;
	int i, j;

	errno = 0;
	lp = linebuf;
	while (c = *lp++)
		output(c,out);
	if ( ov )
	{
		putc( '\n', out );
		fflush(out);
		ioctl( fileno(out), SETSTATE, vpltmode );
		/* plot character */
		for ( lp=ovbuf; lp < &ovbuf[2*LINELN]; )
			putc( *lp++, out );
		fflush(out);
		ioctl(fileno(out), SETSTATE, vprtmode);
	}
	if (ff > 0) {
		putc('\014', out);
		npages++;
	} else if ( ov==0 )
		putc('\n', out);
	if (ferror(out)) {
		printf("Versatec IO error\n");
		exit(1);
	}
}

/* not used here */
xoutput(c,fp)
register	char	c;
register	FILE	*fp;
{

	if (c == -1)
		return;
	c &= 0177;
	if (c == 0177)
		putc('^',fp), c = '?';
	if (c == 033)
		c = '$';
	if (c < ' ') switch (c) {

	case '\n':
		break;

	case '\f':
	case '\b':
	case '\t':
	case '\r':
#ifdef	VERSATEC
	case '\05':
#endif
		break;

	default:
		putc('^',fp);
			c |= 0100;
	}
	putc(c,fp);
}
